//---------------------------------------------------------------------------
//
//   Import STL
//
//          Copyright(C) 2011, Claybird
//          Licensed under New BSD License
//
//
//---------------------------------------------------------------------------

#define _CRT_SECURE_NO_WARNINGS
#define WIN32_LEAN_AND_MEAN
#include <windows.h>
#include <stdio.h>
#include <stdlib.h>
#include <vector>
#include <list>
#include <string>
#include "MQPlugin.h"

#define COUNTOF(x) (sizeof(x)/sizeof(x[0]))
BOOL LoadSTL(const char*filename,MQDocument doc);

//---------------------------------------------------------------------------
//  DllMain
//---------------------------------------------------------------------------
BOOL APIENTRY DllMain( HANDLE hModule, 
                       DWORD  ul_reason_for_call, 
                       LPVOID lpReserved
					 )
{
	//vOCƂĂ͓ɕKvȏ͂Ȃ̂ŁATRUEԂ
    return TRUE;
}

//---------------------------------------------------------------------------
//  MQGetPlugInID
//    vOCIDԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT void MQGetPlugInID(DWORD *Product, DWORD *ID)
{
	// v_Ng(Җ)IDAS64bit̒lƂĕԂ
	// l͑ƏdȂ悤ȃ_Ȃ̂ŗǂ
	*Product = 0xB3A8500C;
	*ID      = 0x75D0CE87;
}

//---------------------------------------------------------------------------
//  MQGetPlugInName
//    vOCԂB
//    ̊֐[vOCɂ]\ɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQGetPlugInName(void)
{
	// vOC
	return "STL Importer Ver.0.02      Copyright(C) 2011, Claybird";
}

//---------------------------------------------------------------------------
//  MQGetPlugInType
//    vOC̃^CvԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT int MQGetPlugInType(void)
{
	// ͗pvOCł
	return MQPLUGIN_TYPE_IMPORT;
}

//---------------------------------------------------------------------------
//  MQEnumFileType
//    ͂܂͏o͉\ȃt@C^CvԂB
//    t@C^Cv͕ʖۑ̃_CAOɕ\B
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileType(int index)
{
	switch(index){
	case 0: return "STL (*.stl)";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQEnumFileExt
//    ͂܂͏o͉\ȊgqԂB
//    ̊֐͋NɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT const char *MQEnumFileExt(int index)
{
	switch(index){
	case 0: return "stl";
	}
	return NULL;
}

//---------------------------------------------------------------------------
//  MQImportFile
//    [ǂݍ]hbOhbvœǂݍނƂɌĂяoB
//---------------------------------------------------------------------------
MQPLUGIN_EXPORT BOOL MQImportFile(int index, const char *filename, MQDocument doc)
{
	switch(index){
	case 0: return LoadSTL(filename, doc);
	}
	return FALSE;
}

//sƂɐ؂蕪ăXgɂ
bool SplitLines(const std::vector<BYTE>& cData,std::list<std::string> &r_LineList)
{
	//sobt@NA
	r_LineList.clear();

	LPCSTR p=(LPCSTR)&cData[0];
	const LPCSTR pEnd=(LPCSTR)(&cData[0]+cData.size());
	//
	std::string strLine;
	for(;p!=pEnd;p++){
		if(*p=='\n'||*p=='\r'||*p=='\0'){
			if(!strLine.empty()){	//s폜
				r_LineList.push_back(strLine);
			}
			strLine.clear();
		}
		else 
			strLine+=*p;
	}
	if(!strLine.empty()){
		r_LineList.push_back(strLine);
	}
	return true;
}

bool beginWith(LPCTSTR line,LPCTSTR keyword)
{
	return 0==strncmp(line,keyword,strlen(keyword));
}

bool beginWith(const std::string &line,LPCTSTR keyword)
{
	return beginWith(line.c_str(),keyword);
}

struct smart_obj_ptr{
	MQObject obj;
	smart_obj_ptr(MQObject _obj):obj(_obj){}
	~smart_obj_ptr(){
		if(obj){
			obj->DeleteThis();
		}
	}
	void detach(){
		obj=NULL;
	}
};

BOOL LoadSTLAscii(const std::vector<BYTE>& cData, MQDocument doc)
{
	std::list<std::string> cLines;
	SplitLines(cData,cLines);
	if(cLines.empty())return FALSE;

	std::list<std::string>::const_iterator ite=cLines.begin();
	std::list<std::string>::const_iterator end=cLines.end();

	// IuWFNg̍쐬
	MQObject obj = MQ_CreateObject();
	smart_obj_ptr smartptr(obj);	//X}[g|C^IȂ
	MQObj_SetName(obj, (*ite).c_str()+strlen("solid "));	//IuWFNg

	int indexArray[3];
	int faceVertex=0;
	for(;ite!=end;++ite){
		std::string line;
		size_t len=(*ite).size();
		for(size_t idx=0;idx<len;idx++){
			if((*ite)[idx]!=' ' && (*ite)[idx]!='\t'){
				line=(*ite).c_str()+idx;
				break;
			}
		}
		if(line.empty())continue;

		if(beginWith(line,"facet normal") || beginWith(line,"outer loop") || beginWith(line,"endfacet")){
			if(faceVertex==0)continue;	//
			else return FALSE;	//error
		}else if(beginWith(line,"vertex ")){
			if(faceVertex>=3)return FALSE;	//error

			//ǂݍ
			MQPoint vertex;
			if(3!=sscanf( line.c_str()+strlen("vertex "),"%f %f %f",&vertex.x,&vertex.y,&vertex.z)){
				return FALSE;//error
			}
			indexArray[faceVertex]=obj->AddVertex(vertex);
			if(indexArray[faceVertex]==-1)return FALSE;	//s
			faceVertex++;
		}else if(beginWith(line,"endloop")){
			if(faceVertex==3){
				obj->AddFace(faceVertex,indexArray);
				faceVertex=0;
			}else{
				return FALSE;	//error
			}
		}
	}

	// ʂ܂o^ĂȂȂFALSEԂ
	if(obj->GetFaceCount() == 0){
		return FALSE;
	}

	// e|S̓ooł邽߁Aʒu(ۂɂ͏_덷l
	// 0.0001ȉ̋)ɂ邷ׂĒ_
	obj->OptimizeVertex(0.0001f, NULL);

	//X}[g|C^̊ǗI
	smartptr.detach();

	// IuWFNghLg֓o^
	doc->AddObject(obj);

	return TRUE;
}

#pragma pack(push,1)
struct FACE_BIN
{
	float norm[3];
	float v0[3];
	float v1[3];
	float v2[3];
	unsigned __int16 dummy;
};
#pragma pack(pop)

BOOL LoadSTLBinary(const std::vector<BYTE>& cData, MQDocument doc)
{
	const int HEADERSIZE=80;
	unsigned __int32 faceCount = 0;
	if(cData.size()<=HEADERSIZE+sizeof(faceCount))return FALSE;	//wb_Ȃ

	const BYTE* pData=&cData[0];
	//---wb_XLbv
	pData+=HEADERSIZE;

	// o͌̎Opʂ̐𐔂
	memcpy(&faceCount,pData,sizeof(faceCount));
	pData+=sizeof(faceCount);

	//TCY͏\?
	if(cData.size()<HEADERSIZE+sizeof(faceCount)+sizeof(FACE_BIN)*faceCount)return FALSE;

	// IuWFNg̍쐬
	MQObject obj = MQ_CreateObject();
	smart_obj_ptr smartptr(obj);	//X}[g|C^IȂ
	//MQObj_SetName(obj, "" );	//IuWFNg͖

	//---ʖɏ
	for(unsigned __int32 idx=0; idx<faceCount; idx++){
		int indexArray[3];
		FACE_BIN face;

		memcpy(&face,pData,sizeof(face));
		pData+=sizeof(face);

		MQPoint pt0(face.v0[0],face.v0[1],face.v0[2]);
		MQPoint pt1(face.v1[0],face.v1[1],face.v1[2]);
		MQPoint pt2(face.v2[0],face.v2[1],face.v2[2]);

		indexArray[0]=obj->AddVertex(pt0);
		indexArray[1]=obj->AddVertex(pt1);
		indexArray[2]=obj->AddVertex(pt2);

		obj->AddFace(3,indexArray);
	}

	// ʂ܂o^ĂȂȂFALSEԂ
	if(obj->GetFaceCount() == 0){
		return FALSE;
	}

	// e|S̓ooł邽߁Aʒu(ۂɂ͏_덷l
	// 0.0001ȉ̋)ɂ邷ׂĒ_
	obj->OptimizeVertex(0.0001f, NULL);

	//X}[g|C^̊ǗI
	smartptr.detach();

	// IuWFNghLg֓o^
	doc->AddObject(obj);

	return TRUE;
}


// STL`
BOOL LoadSTL(const char *filename, MQDocument doc)
{
	const LPCTSTR lpHeader="solid ";
	FILE* fp=fopen(filename,"rb");
	if(!fp)return FALSE;

	//f[^Ƀ[h
	std::vector<BYTE> cData;
	const int READSIZE=1024*1024;
	std::vector<BYTE> cTmp(READSIZE);
	for(;;){
		int read=fread(&cTmp[0],sizeof(cTmp[0]),READSIZE,fp);
		cData.insert(cData.end(),&cTmp[0],&cTmp[0]+read);
		if(read<READSIZE)break;
	}
	fclose(fp);

	//---oCiAXL[𔻕

	if(cData.size()<strlen(lpHeader)){
		//ǂłȂ
		return FALSE;
	}

	if(strncmp((const char*)&cData[0],lpHeader,strlen(lpHeader))==0){	//ASCII
		if(!LoadSTLAscii(cData,doc)){
			//NOTE:	"solid "Ŏn܂ɂ炸oCi`ŋLqĂAsV̈t@CHɂ邽
			return LoadSTLBinary(cData,doc);
		}
		return TRUE;
	}else{	//BINARY
		return LoadSTLBinary(cData,doc);
	}
}
